import React from 'react'
import { styled } from '../../stitches.config'

export const Box = styled('div', {
  variants: {
    noWrap: {
      flexWrap: 'nowrap',
    },
    display: {
      block: { display: 'block' },
      flex: { display: 'flex' },
      'inline-flex': { display: 'inline-flex' },
      grid: { display: 'grid' },
    },
    direction: {
      row: { flexDirection: 'row' },
      'row-reverse': { flexDirection: 'row-reverse' },
      column: { flexDirection: 'column' },
      'column-reverse': { flexDirection: 'column-reverse' },
    },
    justifyContent: {
      start: { justifyContent: 'flex-start' },
      end: { justifyContent: 'flex-end' },
      center: { justifyContent: 'center' },
      between: { justifyContent: 'space-between' },
      evenly: { justifyContent: 'space-evenly' },
      around: { justifyContent: 'space-around' },
    },
    textAlign: {
      left: { textAlign: 'left' },
      center: { textAlign: 'center' },
      right: { textAlign: 'right' },
    },
    whiteSpace: {
      pre: { whiteSpace: 'pre' },
      'pre-wrap': { whiteSpace: 'pre-wrap' },
      'pre-line': { whiteSpace: 'pre-line' },
      'no-wrap': { whiteSpace: 'nowrap' },
      'break-spaces': { whiteSpace: 'break-spaces' },
    },
    background: {},
    alignItems: {
      start: { alignItems: 'flex-start' },
      end: { alignItems: 'flex-end' },
      center: { alignItems: 'center' },
      baseline: { alignItems: 'baseline' },
      stretch: { alignItems: 'stretch' },
    },
    radius: {
      xxs: { borderRadius: '$radius$xxs' },
      xs: { borderRadius: '$radius$xs' },
      s: { borderRadius: '$radius$s' },
      sm: { borderRadius: '$radius$sm' },
      m: { borderRadius: '$radius$m' },
      ml: { borderRadius: '$radius$ml' },
      l: { borderRadius: '$radius$l' },
      xl: { borderRadius: '$radius$xl' },
      xxl: { borderRadius: '$radius$xxl' },
      xxxl: { borderRadius: '$radius$xxxl' },
    },
    padding: {
      xxs: { padding: '$space$xxs' },
      xs: { padding: '$space$xs' },
      s: { padding: '$space$s' },
      sm: { padding: '$space$sm' },
      m: { padding: '$space$m' },
      ml: { padding: '$space$ml' },
      l: { padding: '$space$l' },
      xl: { padding: '$space$xl' },
      xxl: { padding: '$space$xxl' },
      xxxl: { padding: '$space$xxxl' },
    },
    py: {
      xxs: { paddingTop: '$space$xxs', paddingBottom: '$space$xxs' },
      xs: { paddingTop: '$space$xs', paddingBottom: '$space$xs' },
      s: { paddingTop: '$space$s', paddingBottom: '$space$s' },
      sm: { paddingTop: '$space$sm', paddingBottom: '$space$sm' },
      m: { paddingTop: '$space$m', paddingBottom: '$space$m' },
      ml: { paddingTop: '$space$ml', paddingBottom: '$space$ml' },
      l: { paddingTop: '$space$l', paddingBottom: '$space$l' },
      xl: { paddingTop: '$space$xl', paddingBottom: '$space$xl' },
      xxl: { paddingTop: '$space$xxl', paddingBottom: '$space$xxl' },
      xxxl: { paddingTop: '$space$xxxl', paddingBottom: '$space$xxxl' },
    },
    px: {
      xxs: { paddingLeft: '$space$xxs', paddingRight: '$space$xxs' },
      xs: { paddingLeft: '$space$xs', paddingRight: '$space$xs' },
      s: { paddingLeft: '$space$s', paddingRight: '$space$s' },
      sm: { paddingLeft: '$space$sm', paddingRight: '$space$sm' },
      m: { paddingLeft: '$space$m', paddingRight: '$space$m' },
      ml: { paddingLeft: '$space$ml', paddingRight: '$space$ml' },
      l: { paddingLeft: '$space$l', paddingRight: '$space$l' },
      xl: { paddingLeft: '$space$xl', paddingRight: '$space$xl' },
      xxl: { paddingLeft: '$space$xxl', paddingRight: '$space$xxl' },
      xxxl: { paddingLeft: '$space$xxxl', paddingRight: '$space$xxxl' },
    },
    pt: {
      xxs: { paddingTop: '$space$xxs' },
      xs: { paddingTop: '$space$xs' },
      s: { paddingTop: '$space$s' },
      sm: { paddingTop: '$space$sm' },
      m: { paddingTop: '$space$m' },
      ml: { paddingTop: '$space$ml' },
      l: { paddingTop: '$space$l' },
      xl: { paddingTop: '$space$xl' },
      xxl: { paddingTop: '$space$xxl' },
      xxxl: { paddingTop: '$space$xxxl' },
    },
    pr: {
      xxs: { paddingRight: '$space$xxs' },
      xs: { paddingRight: '$space$xs' },
      s: { paddingRight: '$space$s' },
      sm: { paddingRight: '$space$sm' },
      m: { paddingRight: '$space$m' },
      ml: { paddingRight: '$space$ml' },
      l: { paddingRight: '$space$l' },
      xl: { paddingRight: '$space$xl' },
      xxl: { paddingRight: '$space$xxl' },
      xxxl: { paddingRight: '$space$xxxl' },
    },
    pb: {
      xxs: { paddingBottom: '$space$xxs' },
      xs: { paddingBottom: '$space$xs' },
      s: { paddingBottom: '$space$s' },
      sm: { paddingBottom: '$space$sm' },
      m: { paddingBottom: '$space$m' },
      ml: { paddingBottom: '$space$ml' },
      l: { paddingBottom: '$space$l' },
      xl: { paddingBottom: '$space$xl' },
      xxl: { paddingBottom: '$space$xxl' },
      xxxl: { paddingBottom: '$space$xxxl' },
    },
    pl: {
      xxs: { paddingLeft: '$space$xxs' },
      xs: { paddingLeft: '$space$xs' },
      s: { paddingLeft: '$space$s' },
      sm: { paddingLeft: '$space$sm' },
      m: { paddingLeft: '$space$m' },
      ml: { paddingLeft: '$space$ml' },
      l: { paddingLeft: '$space$l' },
      xl: { paddingLeft: '$space$xl' },
      xxl: { paddingLeft: '$space$xxl' },
      xxxl: { paddingLeft: '$space$xxxl' },
    },
    margin: {
      xxs: { margin: '$space$xxs' },
      xs: { margin: '$space$xs' },
      s: { margin: '$space$s' },
      sm: { margin: '$space$sm' },
      m: { margin: '$space$m' },
      ml: { margin: '$space$ml' },
      l: { margin: '$space$l' },
      xl: { margin: '$space$xl' },
      xxl: { margin: '$space$xxl' },
      xxxl: { margin: '$space$xxxl' },
    },
    my: {
      xxs: { marginTop: '$space$xxs', marginBottom: '$space$xxs' },
      xs: { marginTop: '$space$xs', marginBottom: '$space$xs' },
      s: { marginTop: '$space$s', marginBottom: '$space$s' },
      sm: { marginTop: '$space$sm', marginBottom: '$space$sm' },
      m: { marginTop: '$space$m', marginBottom: '$space$m' },
      ml: { marginTop: '$space$ml', marginBottom: '$space$ml' },
      l: { marginTop: '$space$l', marginBottom: '$space$l' },
      xl: { marginTop: '$space$xl', marginBottom: '$space$xl' },
      xxl: { marginTop: '$space$xxl', marginBottom: '$space$xxl' },
      xxxl: { marginTop: '$space$xxxl', marginBottom: '$space$xxxl' },
    },
    mx: {
      xxs: { marginLeft: '$space$xxs', marginRight: '$space$xxs' },
      xs: { marginLeft: '$space$xs', marginRight: '$space$xs' },
      s: { marginLeft: '$space$s', marginRight: '$space$s' },
      sm: { marginLeft: '$space$sm', marginRight: '$space$sm' },
      m: { marginLeft: '$space$m', marginRight: '$space$m' },
      ml: { marginLeft: '$space$ml', marginRight: '$space$ml' },
      l: { marginLeft: '$space$l', marginRight: '$space$l' },
      xl: { marginLeft: '$space$xl', marginRight: '$space$xl' },
      xxl: { marginLeft: '$space$xxl', marginRight: '$space$xxl' },
      xxxl: { marginLeft: '$space$xxxl', marginRight: '$space$xxxl' },
    },
    mt: {
      xxs: { marginTop: '$space$xxs' },
      xs: { marginTop: '$space$xs' },
      s: { marginTop: '$space$s' },
      sm: { marginTop: '$space$sm' },
      m: { marginTop: '$space$m' },
      ml: { marginTop: '$space$ml' },
      l: { marginTop: '$space$l' },
      xl: { marginTop: '$space$xl' },
      xxl: { marginTop: '$space$xxl' },
      xxxl: { marginTop: '$space$xxxl' },
    },
    mr: {
      xxs: { marginRight: '$space$xxs' },
      xs: { marginRight: '$space$xs' },
      s: { marginRight: '$space$s' },
      sm: { marginRight: '$space$sm' },
      m: { marginRight: '$space$m' },
      ml: { marginRight: '$space$ml' },
      l: { marginRight: '$space$l' },
      xl: { marginRight: '$space$xl' },
      xxl: { marginRight: '$space$xxl' },
      xxxl: { marginRight: '$space$xxxl' },
    },
    mb: {
      xxs: { marginBottom: '$space$xxs' },
      xs: { marginBottom: '$space$xs' },
      s: { marginBottom: '$space$s' },
      sm: { marginBottom: '$space$sm' },
      m: { marginBottom: '$space$m' },
      ml: { marginBottom: '$space$ml' },
      l: { marginBottom: '$space$l' },
      xl: { marginBottom: '$space$xl' },
      xxl: { marginBottom: '$space$xxl' },
      xxxl: { marginBottom: '$space$xxxl' },
    },
    ml: {
      xxs: { marginLeft: '$space$xxs' },
      xs: { marginLeft: '$space$xs' },
      s: { marginLeft: '$space$s' },
      sm: { marginLeft: '$space$sm' },
      m: { marginLeft: '$space$m' },
      ml: { marginLeft: '$space$ml' },
      l: { marginLeft: '$space$l' },
      xl: { marginLeft: '$space$xl' },
      xxl: { marginLeft: '$space$xxl' },
      xxxl: { marginLeft: '$space$xxxl' },
    },
  },
})

Box.displayName = 'Box'
Box.defaultProps = {
  as: 'div',
}

// Box.propTypes = {
//   children: node.isRequired,
//   className: oneOfType([string, object]),
//   as: string,
//   inline: bool,
// }

export default Box
